package es.upm.dit.adsw.tema2.balls.b_critical_zone_wait;

public class Monitor {
    private int MAX = 3;
    private int cuantas = 0;

    public synchronized void entrar() {
        while (cuantas >= MAX)
            waiting();
        cuantas++;
    }

    public synchronized void salir() {
        if (cuantas < 0)
            throw new IllegalStateException();
        if (cuantas > MAX)
            throw new IllegalStateException();
        cuantas--;
        notifyAll();
    }

    private void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
