package es.upm.dit.adsw.tema2.balls.c_readers_writers;

import java.util.ArrayList;
import java.util.List;

public class RW_Monitor_4 extends RW_Monitor {
    private int nReaders = 0;
    private int nWriters = 0;

    private List<Thread> waitingWriters = new ArrayList<>();

    public synchronized void openReading() {
        while (!canRead())
            waiting();
        nReaders++;
        invariant();
    }

    private boolean canRead() {
        if (nWriters > 0) return false;
        if (waitingWriters.size() > 0) return false;
        return true;
    }

    public synchronized void closeReading() {
        nReaders--;
        notifyAll();
        invariant();
    }

    public synchronized void openWriting() {
        Thread me = Thread.currentThread();
        waitingWriters.add(me);
        while (!canWrite(me))
            waiting();
        waitingWriters.remove(me);
        nWriters++;
        invariant();
    }

    private boolean canWrite(Thread me) {
        if (nReaders > 0) return false;
        if (nWriters > 0) return false;
        if (waitingWriters.get(0) != me) return false;
        return true;
    }

    public synchronized void closeWriting() {
        nWriters--;
        notifyAll();
        invariant();
    }
}
