package es.upm.dit.adsw.tema2.bg_task;

import java.util.Date;

/**
 * Tarea que se ejecuta en segundo plano.
 */
public class BgTask1
        implements Runnable {
    private String name;
    private boolean running;
    private boolean ready = false;
    private String result = null;

    /**
     * Constructor.
     *
     * @param name nombre de la tarea.
     */
    public BgTask1(String name) {
        this.name = name;
    }

    /**
     * Para terminar.
     */
    public synchronized void quit() {
        running = false;
    }

    /**
     * Para conocer el resultado. Espera a que esté listo.
     *
     * @return resultado.
     */
    public synchronized String getResult() {
        while (!ready)
            waiting();
        return result;
    }

    private synchronized void setResult(String s) {
        result = s;
        ready = true;
        notifyAll();
    }

    @Override
    public void run() {
        running = true;
        while (running) {
            Nap.sleep(1000);
            if (Math.random() < .1) {
                setResult(name + ": " + new Date());
                return;
            }
        }
        setResult(null);
    }

    private void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
