package es.upm.dit.adsw.tema2.bg_task;

import java.util.Date;

/**
 * Tarea que se ejecuta en segundo plano.
 */
public class BgTask2
        implements Runnable {
    private String name;
    private Listener listener;
    private boolean running;

    /**
     * Constructor.
     *
     * @param name nombre de la tarea.
     */
    public BgTask2(String name) {
        this.name = name;
    }

    /**
     * Para anunciar el resultado cuando esté listo.
     *
     * @param listener agente
     */
    public void setListener(Listener listener) {
        this.listener = listener;
    }

    /**
     * Para terminar.
     */
    public synchronized void quit() {
        running = false;
    }

    private void setResult(String result) {
        if (listener != null)
            listener.publish(result);
    }

    @Override
    public void run() {
        running = true;
        while (running) {
            Nap.sleep(1000);
            if (Math.random() < .05) {
                setResult(name + ": " + new Date());
                return;
            }
        }
    }
}
