package es.upm.dit.adsw.tema2.bounded_buffer;

import java.util.ArrayList;
import java.util.List;

public class Buffer1<E>
        implements Buffer<E> {
    private final List<E> data;
    private final int SIZE;

    public Buffer1(int size) {
        this.SIZE = size;
        data = new ArrayList<E>();
    }

    public synchronized void put(E x)
            throws InterruptedException {
            while (data.size() >= SIZE)
                wait();
        data.add(x);
        if (data.size() > SIZE)
            throw new IllegalStateException("buffer desbordado");
        notifyAll();
    }

    public synchronized E get()
            throws InterruptedException {
            if (data.size() > SIZE)
                throw new IllegalStateException("buffer desbordado");
        while (data.isEmpty())
            wait();
        notifyAll();
        return data.remove(0);
    }

    public synchronized boolean isEmpty() {
        return data.isEmpty();
    }

    private boolean p(double x) {
        return 100 * Math.random() < x;
    }
}
