package es.upm.dit.adsw.tema2.bounded_buffer;

import java.util.Random;

public class Consumidor extends Thread {
    private final Random random = new Random();
    private final String id;
    private final Buffer<String> buffer;
    private volatile boolean parado = true;
    private final LogWindow logWindow;

    public Consumidor(String id, Buffer<String> buffer) {
        this.id = id;
        setName(id);
        this.buffer = buffer;
        logWindow = new LogWindow(this);
    }

    @Override
    public void run() {
        try {
            while (true) {
                if (!parado) {
                    String msg = buffer.get();
                    logWindow.println(id + " consume " + msg);
                }
                sleep(random.nextInt(2) * 1000);
            }
        } catch (InterruptedException e) {
            logWindow.println(e.toString());
        }
        logWindow.println(id + " acaba");
    }

    public void parar() {
        parado = true;
    }

    public void arrancar() {
        parado = false;
    }
}
