package es.upm.dit.adsw.tema2.contador;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Crazy {
    private int cuenta = 0;
    Lock cerrojo = new ReentrantLock();

    void incrementa(int v) {
        cerrojo.lock();
//        cuenta += v;
        int r1 = cuenta;
        int r2 = cuenta;
        r1 = r1 + v;
        nap(100);
        r2 = cuenta + v;
        cuenta = r1;
        cerrojo.unlock();
        if (r1 != r2)
            System.err.printf("r1: %d; r2: %d; cuenta: %d%n", r1, r2, cuenta);
    }

/*
    void incrementa(int v) {
        int registro;
        synchronized (this) {
//        cuenta += v;
            registro = cuenta;
            registro = registro + v;
            nap(100);
            cuenta = registro;
        }
        if (registro != cuenta)
            System.err.printf("registro: %d; cuenta: %d%n", registro, cuenta);
    }
*/

    void decrementa(int v) {
        try {
            cerrojo.lock();
            cuenta -= v;
        } finally {
            cerrojo.unlock();
        }
    }

    public int getN() {
        return cuenta;
    }

    private static void nap(int ms) {
        try {
            Thread.sleep((long) (ms * Math.random()));
        } catch (InterruptedException ignored) {
        }
    }

    public static void main(String[] args)
            throws InterruptedException {
        Crazy cc = new Crazy();

        List<Thread> threadList = new ArrayList<>();
        for (int i = 0; i < 100; i++)
            threadList.add(new Robot(cc));

        for (Thread thread : threadList)
            thread.start();     // arranca la thread
        for (Thread thread : threadList)
            thread.join();      // espera a que termine la thread
        System.out.println("getV(): " + cc.getN());
    }

/*
    private static class Robot extends Thread {
        private final Crazy cc;

        Robot(Crazy cc) {
            this.cc = cc;
        }

        @Override
        public void run() {
            nap(100);
            cc.incrementa(1);
            nap(100);
            cc.decrementa(1);
        }
    }
*/

    private static class Robot extends Thread {
        private final Crazy cc;

        Robot(Crazy cc) {
            this.cc = cc;
        }

        @Override
        public void run() {
            while (true) {
                nap(100);
                cc.incrementa(1);
            }
        }
    }
}
