package es.upm.dit.adsw.tema2.object_pool;

import java.util.ArrayList;
import java.util.List;

public class Pool {
    private final int MAX = 100;
    private final List<MyObject> reservoir = new ArrayList<>();
    private int created = 0;

    public synchronized MyObject get() {
        while (reservoir.isEmpty() && created >= MAX)
            waiting();
        if (reservoir.size() > 0)
            return reservoir.remove(0);
        created++;
        return new MyObject();
    }

    public synchronized void put(MyObject object) {
        reservoir.add(object);
    }

    private void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
