package es.upm.dit.adsw.tema2.philosophers.philosophers1m2;

import es.upm.dit.adsw.tema2.philosophers.Nap;

import java.awt.*;
import java.util.concurrent.Semaphore;

public class Philosopher
        extends Thread {
    public static final Color THINKING = Color.BLUE;
    public static final Color EATING = Color.RED;

    private final int id;
    private final Ball ball;
    private Semaphore semaphore;
    private final Chopstick need1;
    private final Chopstick need2;

    public Philosopher(int id, Ball ball, Semaphore semaphore, Chopstick need1, Chopstick need2) {
        this.id = id;
        this.ball = ball;
        this.semaphore = semaphore;
        this.need1 = need1;
        this.need2 = need2;
    }

    @Override
    public void run() {
        while (true) {
            ball.set(THINKING);
            Nap.random(1000, 3000);

            TestSuite.getBarrier().await();
            Nap.random(0, 20);
            try {
                semaphore.acquire();
            } catch (InterruptedException ignored) {
            }
            need1.take();
//            Nap.sleep(500);
            need2.take();
            semaphore.release();

            ball.set(EATING);
            Nap.random(1000, 3000);
            need1.put();
            need2.put();
        }
    }
}
